#include <stdio.h>
#include <stdlib.h>

int uloh,ul;
int N,C,R;
const int  MAX = 1010;
const MAXBUF = MAX*MAX;
int sx[4] = {1,0,-1,0};
int sy[4] = {0,1,0,-1};

int st[MAX][MAX];
int d1[MAX][MAX];
int buf[MAXBUF];
char p[MAX][MAX];
    
/**/
void compute()
{
  int x,y,xx,yy,max1,max2,gmax;
  int zac, kon, i,j,s;
  int gx,gy;
  gmax = -1;
  zac = kon = 0;
  for(i=1; i<=R; i++) for(j=1; j<=C; j++) 
    if (st[i][j]==1) {
      buf[kon++] = i; buf[kon++] = j;
    }
  while(zac !=kon) {
    yy = buf[zac++]; xx = buf[zac++];
    if (zac==MAXBUF) zac = 0;
    //printf("Spracuvam %d %d\n",xx,yy);
    max1 = max2 = -1;
    for(s=0; s<4; s++) {
      x = xx+sx[s]; 
      y = yy+sy[s];
      //printf("xx = %d, yy = %d, x = %d, y = %d\n",xx,yy,x,y);
      if (d1[y][x]>max1) { max2 = max1; max1 = d1[y][x]; }
      else 
        if (d1[y][x] > max2) { max2 = d1[y][x]; }
      st[y][x]--;
      //printf("st[%d,%d] = %d\n",y,x,st[y][x]);
      if (st[y][x]==1) {
        buf[kon++] = y; buf[kon++] = x;
        //printf("Pushing %d %d",x,y);
        if (kon>=MAXBUF) kon -= MAXBUF;
      }
    }
    if (max1+max2>gmax) { 
      gmax = max1+max2;
      gx = xx; gy = yy;
    }
    d1[yy][xx] = max1+1;
  }
  /*
  for(i=1; i<=R; i++) {
    for(j=1; j<=C; j++) {
      printf("%3d,",d1[i][j]);
    }
    printf("\n");
  }
  printf("gmax = %d, gx=%d, gy = %d\n", gmax,gx,gy);
  */
  if (gmax<0) gmax = 0; 
  else ; //gmax++;
  printf("Maximum rope length is %d.\n",gmax);
}

/**/

int main()
{
  int i,j,s;
  scanf("%d ",&uloh);
  for(ul=1; ul<=uloh; ul++) {
    scanf("%d %d ",&C, &R);
    for(j=0; j<C+2; j++) {
      d1[0][j] = d1[R+1][j] = -1;
      st[0][j] = st[R+1][j] = -0;
      p[0][j] =  p[R+1][j] = '#';  
    }
    for(i=1; i<=R; i++) {
      scanf("%s ",&p[i][1]);
      p[i][0] = p[i][C+1] = '#';
      d1[i][0] = d1[i][C+1] = -1;
      st[i][0] = st[i][C+1] = 0;
    }
    for(i=1; i<=R; i++) for(j=1; j<=C; j++) {
      if (p[i][j]=='#') { d1[i][j] = -1; continue; }
      st[i][j] = 0;
      for(s=0; s<4; s++) {
        if (p[i+sy[s]][j+sx[s]]=='.') st[i][j] ++;
      }
      d1[i][j] = 0; 
    }
    compute();
  }
  
  return 0;
}