#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int uloh,ul;

struct Complex {
  long long r,i;
};

Complex X,B;

int p[120];

void del(Complex C, Complex D, Complex &V, int &zv) {
  long long im,re,de;
  im = C.i*D.r - C.r*D.i;
  re = C.r*D.r + C.i*D.i;
  de = D.r*D.r + D.i*D.i;
  if ((im % de != 0) || (re % de != 0)) {
    zv = 1;
    return;
  }
  zv = 0;
  V.r = re/de;
  V.i = im/de;
}

void compute() {
  int d,a,ii,zv;
  Complex XX,Y;
  ii = 0;
  d = B.r*B.r + B.i*B.i;
  while ((X.r != 0) || (X.i != 0)) {
    for (a=0; a*a<d; a++) {
      XX.i = X.i;
      XX.r = X.r - a;
      del(XX,B,Y,zv);
      if (zv == 0) break;
    }
    //printf("%d %d\n",a,ii);
    if ((a*a>=d) || (ii>=100)) {
      printf("The code cannot be decrypted.\n");
      return;
    }
    p[ii] = a; ii++;
    X.r = Y.r;
    X.i = Y.i;
  }
  if (ii==0) {
    printf("0\n");
    return;
  }
  for (; ii>1; ii--) printf("%d,",p[ii-1]);
  printf("%d\n",p[0]);
}

int main()
{
  int Xr,Xi,Br,Bi;
  scanf("%d ",&uloh);
  for(ul=1; ul<=uloh; ul++) {
    scanf("%d %d %d %d ",&Xr,&Xi,&Br,&Bi);
    X.r = Xr;
    X.i = Xi;
    B.r = Br;
    B.i = Bi;
    compute();
  }
  return 0;
}